---
title: Create a DEM journey
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > DEM
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Create a DEM journey{% #create-a-dem-journey %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                           |
| ----------------- | ------------------------------------------------------ |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/dem/journeys |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/dem/journeys |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/dem/journeys      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/dem/journeys      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/dem/journeys  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/dem/journeys |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/dem/journeys     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/dem/journeys |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/dem/journeys |

### Overview

Create a DEM journey. This endpoint requires the `synthetics_write` permission.

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                         | Type     | Description                                                            |
| ------------ | ----------------------------- | -------- | ---------------------------------------------------------------------- |
|              | data [*required*]        | object   | Data object for a DEM journey create or update request.                |
| data         | attributes [*required*]  | object   | Attributes for creating or updating a DEM journey.                     |
| attributes   | description                   | string   | An optional human-readable description of the journey.                 |
| attributes   | journey_rum [*required*] | object   | The RUM definition for a DEM journey.                                  |
| journey_rum  | filter                        | string   | An optional RUM query filter applied to the entire journey.            |
| journey_rum  | rum_steps [*required*]   | [object] | List of RUM journey steps.                                             |
| rum_steps    | nodes [*required*]       | [object] | List of RUM nodes within a journey step.                               |
| nodes        | app_id                        | string   | The application ID associated with this node.                          |
| nodes        | id                            | string   | The ID of the RUM node element.                                        |
| nodes        | query [*required*]       | string   | The RUM query for matching this node.                                  |
| rum_steps    | type [*required*]        | enum     | The type of a RUM journey step. Allowed enum values: `start,stop,step` |
| journey_rum  | variants                      | [object] | List of variants associated with a DEM journey.                        |
| variants     | filter                        | string   | An optional RUM query filter to scope this variant.                    |
| variants     | id                            | string   | The unique identifier of the variant.                                  |
| variants     | name [*required*]        | string   | The name of the variant.                                               |
| variants     | rum_steps [*required*]   | [object] | List of RUM journey steps.                                             |
| rum_steps    | nodes [*required*]       | [object] | List of RUM nodes within a journey step.                               |
| nodes        | app_id                        | string   | The application ID associated with this node.                          |
| nodes        | id                            | string   | The ID of the RUM node element.                                        |
| nodes        | query [*required*]       | string   | The RUM query for matching this node.                                  |
| rum_steps    | type [*required*]        | enum     | The type of a RUM journey step. Allowed enum values: `start,stop,step` |
| attributes   | name [*required*]        | string   | The name of the DEM journey.                                           |
| attributes   | tags [*required*]        | [string] | List of tags associated with a DEM resource.                           |
| attributes   | variants                      | [object] | List of variants associated with a DEM journey.                        |
| variants     | filter                        | string   | An optional RUM query filter to scope this variant.                    |
| variants     | id                            | string   | The unique identifier of the variant.                                  |
| variants     | name [*required*]        | string   | The name of the variant.                                               |
| variants     | rum_steps [*required*]   | [object] | List of RUM journey steps.                                             |
| rum_steps    | nodes [*required*]       | [object] | List of RUM nodes within a journey step.                               |
| nodes        | app_id                        | string   | The application ID associated with this node.                          |
| nodes        | id                            | string   | The ID of the RUM node element.                                        |
| nodes        | query [*required*]       | string   | The RUM query for matching this node.                                  |
| rum_steps    | type [*required*]        | enum     | The type of a RUM journey step. Allowed enum values: `start,stop,step` |
| data         | type [*required*]        | enum     | The type identifier for DEM journeys. Allowed enum values: `journeys`  |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "description": "Tracks the user checkout flow from cart to confirmation.",
      "journey_rum": {
        "filter": "env:prod",
        "rum_steps": [
          {
            "nodes": [
              {
                "app_id": "app-xyz789",
                "id": "element-id-123",
                "query": "action.name:'checkout'"
              }
            ],
            "type": "start"
          }
        ],
        "variants": [
          {
            "filter": "device.type:mobile",
            "name": "Mobile checkout",
            "rum_steps": [
              {
                "nodes": [
                  {
                    "app_id": "app-xyz789",
                    "id": "element-id-123",
                    "query": "action.name:'checkout'"
                  }
                ],
                "type": "start"
              }
            ]
          }
        ]
      },
      "name": "Checkout Flow",
      "tags": [
        "team:synthetics",
        "env:prod"
      ],
      "variants": [
        {
          "filter": "device.type:mobile",
          "name": "Mobile checkout",
          "rum_steps": [
            {
              "nodes": [
                {
                  "app_id": "app-xyz789",
                  "id": "element-id-123",
                  "query": "action.name:'checkout'"
                }
              ],
              "type": "start"
            }
          ]
        }
      ]
    },
    "type": "journeys"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response body for a single DEM journey.

| Parent field | Field                         | Type      | Description                                                            |
| ------------ | ----------------------------- | --------- | ---------------------------------------------------------------------- |
|              | data [*required*]        | object    | Data object in a DEM journey response.                                 |
| data         | attributes [*required*]  | object    | Attributes returned in a DEM journey response.                         |
| attributes   | created_at [*required*]  | date-time | The timestamp when the journey was created.                            |
| attributes   | created_by [*required*]  | object    | A Datadog user associated with a DEM operation.                        |
| created_by   | email [*required*]       | string    | The email address of the user.                                         |
| created_by   | handle [*required*]      | string    | The handle of the user.                                                |
| created_by   | name [*required*]        | string    | The display name of the user.                                          |
| created_by   | uuid [*required*]        | string    | The UUID of the user.                                                  |
| attributes   | description [*required*] | string    | An optional human-readable description of the journey.                 |
| attributes   | journey_rum [*required*] | object    | The RUM definition for a DEM journey.                                  |
| journey_rum  | filter                        | string    | An optional RUM query filter applied to the entire journey.            |
| journey_rum  | rum_steps [*required*]   | [object]  | List of RUM journey steps.                                             |
| rum_steps    | nodes [*required*]       | [object]  | List of RUM nodes within a journey step.                               |
| nodes        | app_id                        | string    | The application ID associated with this node.                          |
| nodes        | id                            | string    | The ID of the RUM node element.                                        |
| nodes        | query [*required*]       | string    | The RUM query for matching this node.                                  |
| rum_steps    | type [*required*]        | enum      | The type of a RUM journey step. Allowed enum values: `start,stop,step` |
| journey_rum  | variants                      | [object]  | List of variants associated with a DEM journey.                        |
| variants     | filter                        | string    | An optional RUM query filter to scope this variant.                    |
| variants     | id                            | string    | The unique identifier of the variant.                                  |
| variants     | name [*required*]        | string    | The name of the variant.                                               |
| variants     | rum_steps [*required*]   | [object]  | List of RUM journey steps.                                             |
| rum_steps    | nodes [*required*]       | [object]  | List of RUM nodes within a journey step.                               |
| nodes        | app_id                        | string    | The application ID associated with this node.                          |
| nodes        | id                            | string    | The ID of the RUM node element.                                        |
| nodes        | query [*required*]       | string    | The RUM query for matching this node.                                  |
| rum_steps    | type [*required*]        | enum      | The type of a RUM journey step. Allowed enum values: `start,stop,step` |
| attributes   | name [*required*]        | string    | The name of the DEM journey.                                           |
| attributes   | org_id [*required*]      | int64     | The organization ID that owns this journey.                            |
| attributes   | tags [*required*]        | [string]  | List of tags associated with a DEM resource.                           |
| attributes   | test_suite [*required*]  | object    | A test suite associated with a DEM resource.                           |
| test_suite   | id [*required*]          | string    | The ID of the test suite.                                              |
| test_suite   | name [*required*]        | string    | The name of the test suite.                                            |
| attributes   | updated_at [*required*]  | date-time | The timestamp when the journey was last updated.                       |
| attributes   | updated_by [*required*]  | object    | A Datadog user associated with a DEM operation.                        |
| updated_by   | email [*required*]       | string    | The email address of the user.                                         |
| updated_by   | handle [*required*]      | string    | The handle of the user.                                                |
| updated_by   | name [*required*]        | string    | The display name of the user.                                          |
| updated_by   | uuid [*required*]        | string    | The UUID of the user.                                                  |
| attributes   | variants [*required*]    | [object]  | List of variants associated with a DEM journey.                        |
| variants     | filter                        | string    | An optional RUM query filter to scope this variant.                    |
| variants     | id                            | string    | The unique identifier of the variant.                                  |
| variants     | name [*required*]        | string    | The name of the variant.                                               |
| variants     | rum_steps [*required*]   | [object]  | List of RUM journey steps.                                             |
| rum_steps    | nodes [*required*]       | [object]  | List of RUM nodes within a journey step.                               |
| nodes        | app_id                        | string    | The application ID associated with this node.                          |
| nodes        | id                            | string    | The ID of the RUM node element.                                        |
| nodes        | query [*required*]       | string    | The RUM query for matching this node.                                  |
| rum_steps    | type [*required*]        | enum      | The type of a RUM journey step. Allowed enum values: `start,stop,step` |
| data         | id [*required*]          | string    | The unique identifier of the DEM journey.                              |
| data         | type [*required*]        | enum      | The type identifier for DEM journeys. Allowed enum values: `journeys`  |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created_at": "2024-01-15T10:30:00Z",
      "created_by": {
        "email": "jane.doe@example.com",
        "handle": "jane.doe",
        "name": "Jane Doe",
        "uuid": "00000000-0000-0000-0000-000000000001"
      },
      "description": "Tracks the user checkout flow from cart to confirmation.",
      "journey_rum": {
        "filter": "env:prod",
        "rum_steps": [
          {
            "nodes": [
              {
                "app_id": "app-xyz789",
                "id": "element-id-123",
                "query": "action.name:'checkout'"
              }
            ],
            "type": "start"
          }
        ],
        "variants": [
          {
            "filter": "device.type:mobile",
            "id": "variant-001",
            "name": "Mobile checkout",
            "rum_steps": [
              {
                "nodes": [
                  {
                    "app_id": "app-xyz789",
                    "id": "element-id-123",
                    "query": "action.name:'checkout'"
                  }
                ],
                "type": "start"
              }
            ]
          }
        ]
      },
      "name": "Checkout Flow",
      "org_id": 12345,
      "tags": [
        "team:synthetics",
        "env:prod"
      ],
      "test_suite": {
        "id": "suite-abc123",
        "name": "My Journey Suite"
      },
      "updated_at": "2024-01-16T08:00:00Z",
      "updated_by": {
        "email": "jane.doe@example.com",
        "handle": "jane.doe",
        "name": "Jane Doe",
        "uuid": "00000000-0000-0000-0000-000000000001"
      },
      "variants": [
        {
          "filter": "device.type:mobile",
          "id": "variant-001",
          "name": "Mobile checkout",
          "rum_steps": [
            {
              "nodes": [
                {
                  "app_id": "app-xyz789",
                  "id": "element-id-123",
                  "query": "action.name:'checkout'"
                }
              ],
              "type": "start"
            }
          ]
        }
      ]
    },
    "id": "journey-abc123",
    "type": "journeys"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Use a Personal Access Token or Service Access Token export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"  \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/dem/journeys" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${DD_BEARER_TOKEN}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "description": "Tracks the user checkout flow from cart to confirmation.",
      "journey_rum": {
        "rum_steps": [
          {
            "nodes": [
              {
                "query": "action.name:'checkout'"
              }
            ],
            "type": "start"
          },
          {
            "nodes": [
              {
                "query": "action.name:'confirmation'"
              }
            ],
            "type": "stop"
          }
        ]
      },
      "name": "Checkout Flow",
      "tags": [
        "team:synthetics"
      ]
    },
    "type": "journeys"
  }
}
EOF 
                
##### 

```python
"""
Create a DEM journey returns "OK" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.dem_api import DEMApi
from datadog_api_client.v2.model.dem_journey_create_attributes import DemJourneyCreateAttributes
from datadog_api_client.v2.model.dem_journey_create_data import DemJourneyCreateData
from datadog_api_client.v2.model.dem_journey_create_request import DemJourneyCreateRequest
from datadog_api_client.v2.model.dem_journey_rum import DemJourneyRum
from datadog_api_client.v2.model.dem_journey_type import DemJourneyType
from datadog_api_client.v2.model.dem_rum_node import DemRumNode
from datadog_api_client.v2.model.dem_rum_step import DemRumStep
from datadog_api_client.v2.model.dem_rum_step_type import DemRumStepType
from datadog_api_client.v2.model.dem_variant import DemVariant

body = DemJourneyCreateRequest(
    data=DemJourneyCreateData(
        attributes=DemJourneyCreateAttributes(
            description="Tracks the user checkout flow from cart to confirmation.",
            journey_rum=DemJourneyRum(
                filter="env:prod",
                rum_steps=[
                    DemRumStep(
                        nodes=[
                            DemRumNode(
                                query="action.name:'checkout'",
                            ),
                        ],
                        type=DemRumStepType.START,
                    ),
                    DemRumStep(
                        nodes=[
                            DemRumNode(
                                query="action.name:'confirmation'",
                            ),
                        ],
                        type=DemRumStepType.STOP,
                    ),
                ],
                variants=[
                    DemVariant(
                        name="Mobile checkout",
                        rum_steps=[
                            DemRumStep(
                                nodes=[
                                    DemRumNode(
                                        query="action.name:'checkout'",
                                    ),
                                ],
                                type=DemRumStepType.START,
                            ),
                            DemRumStep(
                                nodes=[
                                    DemRumNode(
                                        query="action.name:'confirmation'",
                                    ),
                                ],
                                type=DemRumStepType.STOP,
                            ),
                        ],
                    ),
                ],
            ),
            name="Checkout Flow",
            tags=[
                "team:synthetics",
                "env:prod",
            ],
            variants=[
                DemVariant(
                    name="Mobile checkout",
                    rum_steps=[
                        DemRumStep(
                            nodes=[
                                DemRumNode(
                                    query="action.name:'checkout'",
                                ),
                            ],
                            type=DemRumStepType.START,
                        ),
                        DemRumStep(
                            nodes=[
                                DemRumNode(
                                    query="action.name:'confirmation'",
                                ),
                            ],
                            type=DemRumStepType.STOP,
                        ),
                    ],
                ),
            ],
        ),
        type=DemJourneyType.JOURNEYS,
    ),
)

configuration = Configuration()
configuration.access_token = environ["DD_BEARER_TOKEN"]
with ApiClient(configuration) as api_client:
    api_instance = DEMApi(api_client)
    response = api_instance.create_journey(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" python3 "example.py"
##### 

```ruby
# Create a DEM journey returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.access_token = ENV["DD_BEARER_TOKEN"]
end
api_instance = DatadogAPIClient::V2::DEMAPI.new

body = DatadogAPIClient::V2::DemJourneyCreateRequest.new({
  data: DatadogAPIClient::V2::DemJourneyCreateData.new({
    attributes: DatadogAPIClient::V2::DemJourneyCreateAttributes.new({
      description: "Tracks the user checkout flow from cart to confirmation.",
      journey_rum: DatadogAPIClient::V2::DemJourneyRum.new({
        filter: "env:prod",
        rum_steps: [
          DatadogAPIClient::V2::DemRumStep.new({
            nodes: [
              DatadogAPIClient::V2::DemRumNode.new({
                query: "action.name:'checkout'",
              }),
            ],
            type: DatadogAPIClient::V2::DemRumStepType::START,
          }),
          DatadogAPIClient::V2::DemRumStep.new({
            nodes: [
              DatadogAPIClient::V2::DemRumNode.new({
                query: "action.name:'confirmation'",
              }),
            ],
            type: DatadogAPIClient::V2::DemRumStepType::STOP,
          }),
        ],
        variants: [
          DatadogAPIClient::V2::DemVariant.new({
            name: "Mobile checkout",
            rum_steps: [
              DatadogAPIClient::V2::DemRumStep.new({
                nodes: [
                  DatadogAPIClient::V2::DemRumNode.new({
                    query: "action.name:'checkout'",
                  }),
                ],
                type: DatadogAPIClient::V2::DemRumStepType::START,
              }),
              DatadogAPIClient::V2::DemRumStep.new({
                nodes: [
                  DatadogAPIClient::V2::DemRumNode.new({
                    query: "action.name:'confirmation'",
                  }),
                ],
                type: DatadogAPIClient::V2::DemRumStepType::STOP,
              }),
            ],
          }),
        ],
      }),
      name: "Checkout Flow",
      tags: [
        "team:synthetics",
        "env:prod",
      ],
      variants: [
        DatadogAPIClient::V2::DemVariant.new({
          name: "Mobile checkout",
          rum_steps: [
            DatadogAPIClient::V2::DemRumStep.new({
              nodes: [
                DatadogAPIClient::V2::DemRumNode.new({
                  query: "action.name:'checkout'",
                }),
              ],
              type: DatadogAPIClient::V2::DemRumStepType::START,
            }),
            DatadogAPIClient::V2::DemRumStep.new({
              nodes: [
                DatadogAPIClient::V2::DemRumNode.new({
                  query: "action.name:'confirmation'",
                }),
              ],
              type: DatadogAPIClient::V2::DemRumStepType::STOP,
            }),
          ],
        }),
      ],
    }),
    type: DatadogAPIClient::V2::DemJourneyType::JOURNEYS,
  }),
})
p api_instance.create_journey(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" rb "example.rb"
##### 

```go
// Create a DEM journey returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.DemJourneyCreateRequest{
		Data: datadogV2.DemJourneyCreateData{
			Attributes: datadogV2.DemJourneyCreateAttributes{
				Description: datadog.PtrString("Tracks the user checkout flow from cart to confirmation."),
				JourneyRum: datadogV2.DemJourneyRum{
					Filter: datadog.PtrString("env:prod"),
					RumSteps: []datadogV2.DemRumStep{
						{
							Nodes: []datadogV2.DemRumNode{
								{
									Query: "action.name:'checkout'",
								},
							},
							Type: datadogV2.DEMRUMSTEPTYPE_START,
						},
						{
							Nodes: []datadogV2.DemRumNode{
								{
									Query: "action.name:'confirmation'",
								},
							},
							Type: datadogV2.DEMRUMSTEPTYPE_STOP,
						},
					},
					Variants: []datadogV2.DemVariant{
						{
							Name: "Mobile checkout",
							RumSteps: []datadogV2.DemRumStep{
								{
									Nodes: []datadogV2.DemRumNode{
										{
											Query: "action.name:'checkout'",
										},
									},
									Type: datadogV2.DEMRUMSTEPTYPE_START,
								},
								{
									Nodes: []datadogV2.DemRumNode{
										{
											Query: "action.name:'confirmation'",
										},
									},
									Type: datadogV2.DEMRUMSTEPTYPE_STOP,
								},
							},
						},
					},
				},
				Name: "Checkout Flow",
				Tags: []string{
					"team:synthetics",
					"env:prod",
				},
				Variants: []datadogV2.DemVariant{
					{
						Name: "Mobile checkout",
						RumSteps: []datadogV2.DemRumStep{
							{
								Nodes: []datadogV2.DemRumNode{
									{
										Query: "action.name:'checkout'",
									},
								},
								Type: datadogV2.DEMRUMSTEPTYPE_START,
							},
							{
								Nodes: []datadogV2.DemRumNode{
									{
										Query: "action.name:'confirmation'",
									},
								},
								Type: datadogV2.DEMRUMSTEPTYPE_STOP,
							},
						},
					},
				},
			},
			Type: datadogV2.DEMJOURNEYTYPE_JOURNEYS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewDEMApi(apiClient)
	resp, r, err := api.CreateJourney(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `DEMApi.CreateJourney`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `DEMApi.CreateJourney`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" go run "main.go"
##### 

```java
// Create a DEM journey returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.DemApi;
import com.datadog.api.client.v2.model.DemJourneyCreateAttributes;
import com.datadog.api.client.v2.model.DemJourneyCreateData;
import com.datadog.api.client.v2.model.DemJourneyCreateRequest;
import com.datadog.api.client.v2.model.DemJourneyResponse;
import com.datadog.api.client.v2.model.DemJourneyRum;
import com.datadog.api.client.v2.model.DemJourneyType;
import com.datadog.api.client.v2.model.DemRumNode;
import com.datadog.api.client.v2.model.DemRumStep;
import com.datadog.api.client.v2.model.DemRumStepType;
import com.datadog.api.client.v2.model.DemVariant;
import java.util.Arrays;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
    DemApi apiInstance = new DemApi(defaultClient);

    DemJourneyCreateRequest body =
        new DemJourneyCreateRequest()
            .data(
                new DemJourneyCreateData()
                    .attributes(
                        new DemJourneyCreateAttributes()
                            .description("Tracks the user checkout flow from cart to confirmation.")
                            .journeyRum(
                                new DemJourneyRum()
                                    .filter("env:prod")
                                    .rumSteps(
                                        Arrays.asList(
                                            new DemRumStep()
                                                .nodes(
                                                    Collections.singletonList(
                                                        new DemRumNode()
                                                            .query("action.name:'checkout'")))
                                                .type(DemRumStepType.START),
                                            new DemRumStep()
                                                .nodes(
                                                    Collections.singletonList(
                                                        new DemRumNode()
                                                            .query("action.name:'confirmation'")))
                                                .type(DemRumStepType.STOP)))
                                    .variants(
                                        Collections.singletonList(
                                            new DemVariant()
                                                .name("Mobile checkout")
                                                .rumSteps(
                                                    Arrays.asList(
                                                        new DemRumStep()
                                                            .nodes(
                                                                Collections.singletonList(
                                                                    new DemRumNode()
                                                                        .query(
                                                                            "action.name:'checkout'")))
                                                            .type(DemRumStepType.START),
                                                        new DemRumStep()
                                                            .nodes(
                                                                Collections.singletonList(
                                                                    new DemRumNode()
                                                                        .query(
                                                                            "action.name:'confirmation'")))
                                                            .type(DemRumStepType.STOP))))))
                            .name("Checkout Flow")
                            .tags(Arrays.asList("team:synthetics", "env:prod"))
                            .variants(
                                Collections.singletonList(
                                    new DemVariant()
                                        .name("Mobile checkout")
                                        .rumSteps(
                                            Arrays.asList(
                                                new DemRumStep()
                                                    .nodes(
                                                        Collections.singletonList(
                                                            new DemRumNode()
                                                                .query("action.name:'checkout'")))
                                                    .type(DemRumStepType.START),
                                                new DemRumStep()
                                                    .nodes(
                                                        Collections.singletonList(
                                                            new DemRumNode()
                                                                .query(
                                                                    "action.name:'confirmation'")))
                                                    .type(DemRumStepType.STOP))))))
                    .type(DemJourneyType.JOURNEYS));

    try {
      DemJourneyResponse result = apiInstance.createJourney(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DemApi#createJourney");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" java "Example.java"
##### 

```rust
// Create a DEM journey returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_dem::DEMAPI;
use datadog_api_client::datadogV2::model::DemJourneyCreateAttributes;
use datadog_api_client::datadogV2::model::DemJourneyCreateData;
use datadog_api_client::datadogV2::model::DemJourneyCreateRequest;
use datadog_api_client::datadogV2::model::DemJourneyRum;
use datadog_api_client::datadogV2::model::DemJourneyType;
use datadog_api_client::datadogV2::model::DemRumNode;
use datadog_api_client::datadogV2::model::DemRumStep;
use datadog_api_client::datadogV2::model::DemRumStepType;
use datadog_api_client::datadogV2::model::DemVariant;

#[tokio::main]
async fn main() {
    let body = DemJourneyCreateRequest::new(DemJourneyCreateData::new(
        DemJourneyCreateAttributes::new(
            DemJourneyRum::new(vec![
                DemRumStep::new(
                    vec![DemRumNode::new("action.name:'checkout'".to_string())],
                    DemRumStepType::START,
                ),
                DemRumStep::new(
                    vec![DemRumNode::new("action.name:'confirmation'".to_string())],
                    DemRumStepType::STOP,
                ),
            ])
            .filter("env:prod".to_string())
            .variants(vec![DemVariant::new(
                "Mobile checkout".to_string(),
                vec![
                    DemRumStep::new(
                        vec![DemRumNode::new("action.name:'checkout'".to_string())],
                        DemRumStepType::START,
                    ),
                    DemRumStep::new(
                        vec![DemRumNode::new("action.name:'confirmation'".to_string())],
                        DemRumStepType::STOP,
                    ),
                ],
            )]),
            "Checkout Flow".to_string(),
            vec!["team:synthetics".to_string(), "env:prod".to_string()],
        )
        .description("Tracks the user checkout flow from cart to confirmation.".to_string())
        .variants(vec![DemVariant::new(
            "Mobile checkout".to_string(),
            vec![
                DemRumStep::new(
                    vec![DemRumNode::new("action.name:'checkout'".to_string())],
                    DemRumStepType::START,
                ),
                DemRumStep::new(
                    vec![DemRumNode::new("action.name:'confirmation'".to_string())],
                    DemRumStepType::STOP,
                ),
            ],
        )]),
        DemJourneyType::JOURNEYS,
    ));
    let configuration = datadog::Configuration::new();
    let api = DEMAPI::with_config(configuration);
    let resp = api.create_journey(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Create a DEM journey returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration({
  authMethods: {
    AuthZ: {
      accessToken: process.env.DD_BEARER_TOKEN as string,
    },
  },
});
const apiInstance = new v2.DEMApi(configuration);

const params: v2.DEMApiCreateJourneyRequest = {
  body: {
    data: {
      attributes: {
        description: "Tracks the user checkout flow from cart to confirmation.",
        journeyRum: {
          filter: "env:prod",
          rumSteps: [
            {
              nodes: [
                {
                  query: "action.name:'checkout'",
                },
              ],
              type: "start",
            },
            {
              nodes: [
                {
                  query: "action.name:'confirmation'",
                },
              ],
              type: "stop",
            },
          ],
          variants: [
            {
              name: "Mobile checkout",
              rumSteps: [
                {
                  nodes: [
                    {
                      query: "action.name:'checkout'",
                    },
                  ],
                  type: "start",
                },
                {
                  nodes: [
                    {
                      query: "action.name:'confirmation'",
                    },
                  ],
                  type: "stop",
                },
              ],
            },
          ],
        },
        name: "Checkout Flow",
        tags: ["team:synthetics", "env:prod"],
        variants: [
          {
            name: "Mobile checkout",
            rumSteps: [
              {
                nodes: [
                  {
                    query: "action.name:'checkout'",
                  },
                ],
                type: "start",
              },
              {
                nodes: [
                  {
                    query: "action.name:'confirmation'",
                  },
                ],
                type: "stop",
              },
            ],
          },
        ],
      },
      type: "journeys",
    },
  },
};

apiInstance
  .createJourney(params)
  .then((data: v2.DemJourneyResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" tsc "example.ts"
{% /tab %}
